#include <bits/stdc++.h>
using namespace std;
int main(){
ios_base::sync_with_stdio(false);
cin.tie(0);
int q,n,x,y,ukupno;
cin>>n>>q;
int a[n+1];
int sume[q];
for(int i=1;i<=n;i++){
    cin>>a[i];

}
for(int i=0;i<q;i++){
    cin>>x>>y;
    for(int j=x;j<y;j++){
            if(j==x){
                    ukupno=a[j]&a[j+1];

            }
        else{
            ukupno=ukupno & a[j+1];
        }


    }
    sume[i]=ukupno;

}
for(int i=0;i<q;i++){
    cout<<sume[i]<<endl;
}


return 0;
}